local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Menagerie1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Menagerie1.fbx/Prefab/BearPart/Bear", "PREFAB_ENTERTAINMENT_BEAR")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/LionPart/Lion", "PREFAB_ENTERTAINMENT_LION")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/ElephantPart/Elephant", "PREFAB_ENTERTAINMENT_ELEPHANT")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/MonkeyPart/Monkey", "PREFAB_ENTERTAINMENT_MONKEY")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/RhinocerosPart/Rhinoceros", "PREFAB_ENTERTAINMENT_RHINOCEROS")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/GiraffePart/Giraffe", "PREFAB_ENTERTAINMENT_GIRAFFE")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/CamelPart/Camel", "PREFAB_ENTERTAINMENT_CAMEL")

mod:registerAssetId("models/Menagerie1.fbx/Prefab/PenPart", "PREFAB_ENTERTAINMENT_PEN")	
mod:registerAssetId("models/Menagerie1.fbx/Prefab/WallPart", "PREFAB_ENTERTAINMENT_WALL")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/WallConstructionSteps", "PREFAB_CONSTR_ENTERTAINMENT_WALL")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/GatePart", "PREFAB_ENTERTAINMENT_GATE")
mod:registerAssetId("models/Menagerie1.fbx/Prefab/GateConstructionSteps", "PREFAB_CONSTR_ENTERTAINMENT_GATE")



-- Ground -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/WallPart", { DataType = "COMP_GROUNDED" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/GatePart", { DataType = "COMP_GROUNDED" })



_replenDays = 3
_replenQty = 5


-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/BearPart/Bear", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})

-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/LionPart/Lion", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})
-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/ElephantPart/Elephant", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 5, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})
-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/GiraffePart/Giraffe", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 4, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})
-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/MonkeyPart/Monkey", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 2, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})
-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/RhinocerosPart/Rhinoceros", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})
-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Menagerie1.fbx/Prefab/CamelPart/Camel", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_EXPERIENCE",
    IsReplenishable = true,
	ReplenishDurationInDays = _replenDays,
	ReplenishQuantity = _replenQty,
    ResourceValue = _replenQty, -- how many are gathered with each pick
    AvailableQuantity = _replenQty, -- maximum container stock
    Radius = 3, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/BearPart/Bear", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/CamelPart/Camel", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/ElephantPart/Elephant", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/LionPart/Lion", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/MonkeyPart/Monkey", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/RhinocerosPart/Rhinoceros", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/GiraffePart/Giraffe", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })

-- Building Part
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/BearPart/Bear", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/CamelPart/Camel", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/ElephantPart/Elephant", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/LionPart/Lion", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/MonkeyPart/Monkey", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/RhinocerosPart/Rhinoceros", { DataType = "COMP_BUILDING_PART" })
mod:registerPrefabComponent("models/Menagerie1.fbx/Prefab/GiraffePart/Giraffe", { DataType = "COMP_BUILDING_PART" })



-- Construction Asset -----------------------------------------------------------------------------------------------------------
-- mod:registerAssetId("models/MonasticVillage1.fbx/Prefab/TowerConstructionSteps", "PREFAB_CONSTR_MV_ROUNDTOWER")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/MonasticVillage1.fbx/Prefab/Hut1Part", { "PLATFORM" })



-- Job: Animal Keeper -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_KEEPER",
	JobName = "JOB_ENTERTAINMENT_KEEPER_NAME",
	JobDescription = "JOB_ENTERTAINMENT_KEEPER_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        -- FemaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT",
        -- },
        -- FemaleHatList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT",
		-- },
        -- FemaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT",
        -- },
        -- MaleFrontList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT",
        -- },
        -- MaleHatList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT",
		-- },
        -- MaleBeltList = {
        --     "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT",
        -- },
		WalkAnimation = "WALKING",
		IdleAnimation = "IDLE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_KEEPER"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_KEEPER"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_KEEPER"
    }
})



-- Building Function: Animal Keeper -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_KEEPER",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_KEEPER_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ENTERTAINMENT_KEEPER", 
        Behavior = "BEHAVIOR_GATHER"
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 10,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_EXPERIENCE", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_EXPERIENCE", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Part: Keeper's Stool -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_KEEPER",
	Name = "BUILDING_PART_ENTERTAINMENT_KEEPER_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STOOL"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0.0, 0.0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_KEEPER",
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 4 } },
		-- RessourcesNeeded = {
        -- --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Bear -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_BEAR",
	Name = "BUILDING_PART_ENTERTAINMENT_BEAR_NAME", 
	Category = "CORE",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_BEAR"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.5, 2.5}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 100 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 15 },
		}
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 1 },
		-- }
	}
})



-- Building Part: Lion -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_LION",
	Name = "BUILDING_PART_ENTERTAINMENT_LION_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_LION"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.25, 2.5}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 250 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 20 } 
		},
		RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Camel -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_CAMEL",
	Name = "BUILDING_PART_ENTERTAINMENT_CAMEL_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_CAMEL"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.25, 4}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 200 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 15 } 
		},
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Rhinoceros -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_RHINOCEROS",
	Name = "BUILDING_PART_ENTERTAINMENT_RHINOCEROS_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_RHINOCEROS"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.25, 2.5}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 300 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 15 } 
		},
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Monkey -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_MONKEY",
	Name = "BUILDING_PART_ENTERTAINMENT_MONKEY_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_MONKEY"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1, 1.5}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 100 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 5 },
		},
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Giraffe -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_GIRAFFE",
	Name = "BUILDING_PART_ENTERTAINMENT_GIRAFFE_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_GIRAFFE"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.5, 3}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 350 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 15 }
		},
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Elephant -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_ELEPHANT",
	Name = "BUILDING_PART_ENTERTAINMENT_ELEPHANT_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_ELEPHANT"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {2, 4}, {0.0, 0.0} ),
    --             Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
		BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 500 } },
		UpkeepCost = { 
			{ Resource = "GOLD_COINS", Quantity = 25 } 
		},
		-- RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Pen -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_PEN",
	Name = "BUILDING_PART_ENTERTAINMENT_PEN_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_PEN"
	},
	-- ConstructionVisual = "PREFAB_CONSTR_MV_BEEHIVEHUT1",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {8, 8}, {0.0, 0.0} ),
                Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = true } 
			}
		}
	},
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		-- UpkeepCost = { { Resource = "GOLD", Quantity = 2 } },
		-- RessourcesNeeded = {
        -- --     { Resource = "STONE", Quantity = 8 },
		-- }
	}
})



-- Building Part: Wall -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_WALL",
	Name = "BUILDING_PART_ENTERTAINMENT_WALL_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_WALL"
	},
	ConstructionVisual = "PREFAB_CONSTR_ENTERTAINMENT_WALL",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {4.65, .5}, {0.0, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
            { Resource = "STONE", Quantity = 4 },
            { Resource = "IRON", Quantity = 4 },
		}
	}
})



-- Building Part: Gate -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_GATE",
	Name = "BUILDING_PART_ENTERTAINMENT_GATE_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_GATE"
	},
	ConstructionVisual = "PREFAB_CONSTR_ENTERTAINMENT_GATE",
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createRectangle( {1.25, .5}, {-1.6, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			},
            { 
                Polygon = polygon.createRectangle( {1.25, .5}, {1.6, 0.0} ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 1 } },
		RessourcesNeeded = {
			{ Resource = "STONE", Quantity = 4 },
            { Resource = "IRON", Quantity = 4 },
		}
	}
})