local mod = ...



-- Building Asset Processor
mod:registerAssetProcessor("models/Performer1.fbx", { DataType = "BUILDING_ASSET_PROCESSOR" })



-- Prefab -----------------------------------------------------------------------------------------------------------
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleFront1", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleFront2", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleFront3", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT3")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleHat1", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleHat2", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleHat3", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT3")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleBelt1", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleBelt2", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerFemaleBelt3", "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT3")

mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleFront1", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleFront2", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleFront3", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT3")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleHat1", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleHat2", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleHat3", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT3")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleBelt1", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT1")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleBelt2", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT2")
mod:registerAssetId("models/Performer1.fbx/Prefab/JugglerMaleBelt3", "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT3")

mod:registerAssetId("models/Performer1.fbx/Prefab/PerformerPart/PerformerArrow", "PREFAB_ENTERTAINMENT_ARROW")
mod:registerAssetId("models/Performer1.fbx/Prefab/StoolPart", "PREFAB_ENTERTAINMENT_STOOL")



-- Resource Container -------------------------------------------------------------------------------------
mod:registerPrefabComponent( "models/Performer1.fbx/Prefab/PerformerPart/PerformerArrow", {
    DataType = "COMP_RESOURCE_CONTAINER",
    ResourceData = "RESOURCE_ENTERTAINMENT",
    IsReplenishable = true,
	ReplenishDurationInDays = 3,
	ReplenishQuantity = 3,
    ResourceValue = 1.0, -- how many are gathered with each pick
    AvailableQuantity = 1, -- maximum container stock
    Radius = 0, -- distance from container that the villager will stand to pick
    IsDestroyWhenEmpty = false
    -- HasMaximumWorkstation = true -- not sure what this does, hoping it keeps them from using each other's patrol points
})



-- Plantable -------------------------------------------------------------------------------------
mod:registerPrefabComponent("models/Performer1.fbx/Prefab/PerformerPart/PerformerArrow", { DataType = "COMP_PLANTABLE", MinSpaceBetweenPlant = 1.0 })

-- Building Part
mod:registerPrefabComponent("models/Performer1.fbx/Prefab/PerformerPart/PerformerArrow", { DataType = "COMP_BUILDING_PART" })



-- Construction Asset -----------------------------------------------------------------------------------------------------------
-- mod:registerAssetId("models/MonasticVillage1.fbx/Prefab/TowerConstructionSteps", "PREFAB_CONSTR_MV_ROUNDTOWER")



-- Collider Platform (climbable mesh)  -------------------------------------------------------------------------------------
-- mod:configurePrefabFlagList("models/MonasticVillage1.fbx/Prefab/Hut1Part", { "PLATFORM" })



-- Job: Performer 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_PERFORMER1",
	JobName = "JOB_ENTERTAINMENT_PERFORMER1_NAME",
	JobDescription = "JOB_ENTERTAINMENT_PERFORMER1_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT1",
        },
        FemaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT1",
		},
        FemaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT1",
        },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT1",
        },
        MaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT1",
		},
        MaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT1",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "GRAPE_HARVESTING"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER1"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER1"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER1"
    }
})



-- Job: Performer 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_PERFORMER2",
	JobName = "JOB_ENTERTAINMENT_PERFORMER2_NAME",
	JobDescription = "JOB_ENTERTAINMENT_PERFORMER2_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT2",
        },
        FemaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT2",
		},
        FemaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT2",
        },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT2",
        },
        MaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT2",
		},
        MaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT2",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "GRAPE_CARING"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER2"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER2"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER2"
    }
})



-- Job: Performer 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "JOB",
	Id = "JOB_ENTERTAINMENT_PERFORMER3",
	JobName = "JOB_ENTERTAINMENT_PERFORMER3_NAME",
	JobDescription = "JOB_ENTERTAINMENT_PERFORMER3_DESC",
	IsLockedByDefault = false,
	DefaultBehavior = "BEHAVIOR_GATHER",
	-- UseWorkplaceBehavior = true,
    ProductionDelay = 60.0, -- default 30
	AssetJobProgression = "DEFAULT_JOB_PROGRESSION",
	CharacterSetup = {
		DataType = "CHARACTER_SETUP", 
		-- LeftHandObject = {
		-- 	Model = "PREFAB_TOOL_ENVOY_SCROLL_LONG",
		-- 	WorkAttachName = "Scroll_Anchor", 
		-- 	WalkAttachName = "Scroll_Anchor"
		-- },
        FemaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_FRONT3",
        },
        FemaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_HAT3",
		},
        FemaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_FEMALE_BELT3",
        },
        MaleFrontList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_FRONT3",
        },
        MaleHatList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_HAT3",
		},
        MaleBeltList = {
            "PREFAB_ENTERTAINMENT_JUGGLER_MALE_BELT3",
        },
		WalkAnimation = "WALKING",
		IdleAnimation = "GRINDSTONE"
	}
})

mod:override({
    Id = "NEWCOMER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER3"
    }
})

mod:override({
    Id = "SERF",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER3"
    }
})

mod:override({
    Id = "COMMONER",
    CompatibleJobList = {
        Action = "APPEND",
        "JOB_ENTERTAINMENT_PERFORMER3"
    }
})




-- Building Function: Performer 1 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER1",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER1_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ENTERTAINMENT_PERFORMER1", 
        Behavior = "BEHAVIOR_GATHER"
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 10,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Function: Performer 2 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER2",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER2_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ENTERTAINMENT_PERFORMER2", 
        Behavior = "BEHAVIOR_GATHER"
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 10,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Function: Performer 3 -------------------------------------------------------------------------------------
mod:register({
    DataType = "BUILDING_FUNCTION_MARKET",
    Id = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER3",
	Name = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER3_NAME",
	IsPrivate = false,
    WorkerCapacity = 1,
    RelatedJob = { 
        Job = "JOB_ENTERTAINMENT_PERFORMER3", 
        Behavior = "BEHAVIOR_GATHER"
    },
	TypeList = { "ENTERTAINMENT" },
	IsOverrideCapacity = true,
	CapacityPerSlot = 10,
	InputInventoryCapacity = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
    ResourceListNeeded = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	},
	ResourceProduced = {
		{ Resource = "RESOURCE_ENTERTAINMENT", Quantity = 1 },
	}
})



-- Building Part: Performer's Spot -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_SPOT",
	Name = "BUILDING_PART_ENTERTAINMENT_SPOT_NAME", 
	-- Category = "EXTENSION",
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_ARROW"
	},
	-- BuildingZone = { 
    --     ZoneEntryList = {
    --         { 
    --             Polygon = polygon.createRectangle( {1.0, 1.0}, {0.0, 0.0} ),
    --             Type = { DEFAULT = false, NAVIGABLE = true, GRASS_CLEAR = false } 
	-- 		}
	-- 	}
	-- },
	Cost = {
	},
	IsMovableWhenBuilt = true,
	IsVisibleWhenBuilt = false
})



-- Building Part: Performer's Stool 1 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_PERFORMER1",
	Name = "BUILDING_PART_ENTERTAINMENT_PERFORMER1_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STOOL"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0.0, 0.0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER1",
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 4 } },
		RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Performer's Stool 2 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_PERFORMER2",
	Name = "BUILDING_PART_ENTERTAINMENT_PERFORMER2_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STOOL"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0.0, 0.0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER2",
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 4 } },
		RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		}
	}
})



-- Building Part: Performer's Stool 3 -------------------------------------------------------------------------------------
mod:register({
	DataType = "BUILDING_PART",
	Id = "BUILDING_PART_ENTERTAINMENT_PERFORMER3",
	Name = "BUILDING_PART_ENTERTAINMENT_PERFORMER3_NAME", 
	ConstructorData = {
		DataType = "BUILDING_CONSTRUCTOR_DEFAULT",
		CoreObjectPrefab = "PREFAB_ENTERTAINMENT_STOOL"
	},
	BuildingZone = { 
        ZoneEntryList = {
            { 
                Polygon = polygon.createCircle( 0.5, {0.0, 0.0}, 10 ),
                Type = { DEFAULT = true, NAVIGABLE = true, GRASS_CLEAR = false } 
			}
		}
	},
	AssetBuildingFunction = "BUILDING_FUNCTION_ENTERTAINMENT_PERFORMER3",
	Cost = {
		-- BuildRightTaxes = {	{ Resource = "GOLD", Quantity = 5 } },
		UpkeepCost = { { Resource = "GOLD", Quantity = 4 } },
		RessourcesNeeded = {
        --     { Resource = "STONE", Quantity = 8 },
		}
	}
})